#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include "get_tpad.h"

int get_tpad(char *tpad_name)
{
    int fd;
    char *ptr1, *ptr2;
    
    strcpy (tpad_name, "/dev/tpadXY");
    
    for (ptr1 = "pqrstuvwxyzPQRST"; *ptr1 != 0; ptr1++)
	{
	tpad_name[9] = *ptr1;
	for (ptr2 = "0123456789abcdef"; *ptr2 != 0; ptr2++)
	    {
	    tpad_name[10] = *ptr2;
	    
	    /* 
	     * Try to open this one
	     */

	    /*
	     * Need to open in NONBLOCK mode.  This will cause the open
	     * call to return with EWOULDBLOCK if there is no controlling
	     * process, i.e. no XPAD process for this tpad
	     */
	    if ((fd = open (tpad_name, O_RDWR | O_NONBLOCK)) < 0)
		{
		if (errno == ENOENT)
		    {
		    return (-1); 	/* out of tpads */
		    }
		else
		    {
		    continue;		/* try next one */
		    }
		} /* if */

	    /* 
	     * successful open, must be available 
	     */

    
#if 0
	    /*
	     * The BSD/386 kernel has been changed so that it defaults to
	     * exclusive access mode, so the following code has been taken out.
	     */
	    if (ioctl (fd, TIOCEXCL, 0) < 0)
		{
		printf ("\nCould not set device to exclusive access");
		fflush (stdout);
		continue;
		} /* if */
#endif
	    
	    return (fd);		/* return the file descriptor */
	    }
	}
    
    return (-1);		/* out of tpads */
}
