/*
 * Copyright (c) 1995 by CompuServe Incorporated, Columbus, Ohio
 *
 * Facility:  ?
 *
 * Abstract:
 *
 *     ?
 *
 * Environment:  ?
 *
 * Author:  ?
 *
 * Revision History:
 *
 * 1.0  ?, ?
 *      - Initial revision
 */

#ifndef LOG_H
#define LOG_H

/*
 * External Interfaces
 */
#include <stdio.h>

/*
 * Constants, structures, and typedefs
 */
typedef enum LogLevel_e
    {
    LOG_LEVEL_EMERG,
    LOG_LEVEL_ALERT,
    LOG_LEVEL_CRIT,
    LOG_LEVEL_ERR,
    LOG_LEVEL_WARNING,
    LOG_LEVEL_NOTICE,
    LOG_LEVEL_INFO,
    LOG_LEVEL_DEBUG0,
    LOG_LEVEL_DEBUG1,
    LOG_LEVEL_DEBUG2,
    LOG_LEVEL_DEBUG3
    } LogLevel;

/*
 * External data
 */

/*
 * Function prototypes
 */

void Start_Local_File_Log (char *directory, char *file_name_prefix);
extern void Start_Pipe_Log (char *pipe_command);
extern void Start_User_Log (FILE *user_file_ptr, char *three_letter_program_id,
			    char *line_terminator);
extern void Start_Inhouse_Stderr_Log (char *cs_program_id);
extern void Start_User_Fd_Log (int fd, char *three_letter_program_id,
			       char *line_terminator);
extern void Stop_User_Fd_Log ();
extern void Start_Syslog_Log (char *program_name);
extern void Write_Message_To_Log (LogLevel level, char *source_file_name,
				  int source_file_line_number,
				  char *message);
extern void Write_Va_Message_To_Log (LogLevel level, char *source_file_name,
				     int source_file_line_number,
				     char *message, ...);
extern void Write_Error_To_Log (LogLevel level,
				char *source_file_name,
				int source_file_line_number,
				char *object_description,
				char *operation_description,
				char *compuserve_three_letter_error_id,
				char *message);
extern void Write_System_Error_To_Log (LogLevel level,
				       char *source_file_name,
				       int source_file_line_number,
				       int system_error_number,
				       char *object_description,
				       char *operation_description,
				       char *three_letter_error_id,
				       char *message);
extern void Log_Hidden_System_Error (LogLevel level,
				     char *source_file_name,
				     int source_file_line_number,
				     int system_error_number,
				     char *object_description,
				     char *operation_description,
				     char *message);
void Log_Buffer (char *file, int line, char *buffer, int buffer_size,
		 char *message);
extern void Close_Log ();



#endif
