#include "defs.h"    /* for PROGRAM_ID_FOR_ERRORS, OUTPUT_LINE_TERMINATOR */
#include "ext.h"     /* for cleanup() */
#include "config.h"  /* for RUN_TIME_USER_NAME */
#include "../common/inetcis_common.h"  /* inetcis_status,
					  INETCIS_STATUS_FAILURE,
					  increase_process_limit(),
					  become_user() */

int went_through_exit_handler = 0;


void fix_process_limit ( )
    {
    inetcis_status_type status;
    
    increase_process_limit ();
    status = become_user (RUN_TIME_USER_NAME, PROGRAM_ID_FOR_ERRORS,
			  OUTPUT_LINE_TERMINATOR);
    if (status == INETCIS_STATUS_FAILURE)
	{
	cleanup (0);
	}
    }




void exit_handler ()
    {
    went_through_exit_handler = 1;
    syslog (LOG_DEBUG, "%s %d - debug - passing through exit_handler -"
	    " calling cleanup", __FILE__, __LINE__);
    cleanup (0);
    }
