/*
 * Copyright (c) 1995 by CompuServe Incorporated, Columbus, Ohio
 *
 * Facility:  ?
 *
 * Abstract:
 *
 *     ?
 *
 * Environment:  ?
 *
 * Author:  ?
 *
 * Revision History:
 *
 * 1.0  ?, ?
 *      - Initial revision
 */

/*
 * External Interfaces
 */
#include <sys/types.h>
#include <time.h>
#include <syslog.h>
#include <stdio.h>
#include <stdlib.h>
#include <comdef.h>                  /* CompuServe definitions */
#include <poserr.h>

#ifdef PIPE_WATCH
/*
 * Module-wide definitions
 */
static FILE *pipe_ptr = NULL;
static bool pipe_is_open = FALSE;

/*
 * Global data
 */

/*
 * Table of contents
 */

void Open_Debug_Pipe (char *pipe_command)
    {
    pipe_ptr = popen (pipe_command, "w");
    if (pipe_ptr == NULL)
	{
	syslog (LOG_ERR, "%s %d - err - Error running command %s",
		__FILE__, __LINE__, PIPE_COMMAND);
	return;
	}
    pipe_is_open = TRUE;
    }

bool Debug_Pipe_Is_Open ()
    {
    return pipe_is_open;
    }

void Write_To_Debug_Pipe (const char *message)
    {
    time_t encoded_time;
    struct tm *time_struct_ptr;
    int status;

    encoded_time = time (NULL);
    if (encoded_time == TIME_ERROR)
	{
	syslog (LOG_ERR, "%s %d - err - function call time caused `%m'",
		__FILE__, __LINE__);
	}

    time_struct_ptr = localtime (&encoded_time);

    fprintf (pipe_ptr, "%d:%d:%d %s\n", time_struct_ptr->tm_hour,
	     time_struct_ptr->tm_min, time_struct_ptr->tm_sec, message);
    status = fflush (pipe_ptr);
    if (status == EOF)
	{
	syslog (LOG_ERR, "%s %d - err - fflush caused system error `%m'",
		__FILE__, __LINE__);
	}
    }

void Write_Bytes_To_Debug_Pipe (const char *message, int number_of_bytes,
				char *buffer_ptr)
    {
    time_t encoded_time;
    struct tm *time_struct_ptr;
    int status;

    encoded_time = time (NULL);
    if (encoded_time == TIME_ERROR)
	{
	syslog (LOG_ERR, "%s %d - err - function call time caused `%m'",
		__FILE__, __LINE__);
	}

    time_struct_ptr = localtime (&encoded_time);

    fprintf (pipe_ptr, "%d:%d:%d %s %d bytes ", time_struct_ptr->tm_hour,
	     time_struct_ptr->tm_min, time_struct_ptr->tm_sec, message,
	     number_of_bytes);

    fwrite (buffer_ptr, (size_t) (number_of_bytes < 40 ? number_of_bytes : 40),
	    (size_t) 1, pipe_ptr);

    fputc ('\n', pipe_ptr);

    status = fflush (pipe_ptr);
    if (status == EOF)
	{
	syslog (LOG_ERR, "%s %d - err - fflush caused system error `%m'",
		__FILE__, __LINE__);
	}
    }

void Close_Debug_Pipe ()
    {
    int status;

    status = pclose (pipe_ptr);

    if (status == PCLOSE_ERROR)
	{
	syslog (LOG_ERR, "%s %d - err - pclose caused system error `%m'",
		__FILE__, __LINE__);
	}
    }
#endif
