#!/usr/local/bin/expect

#
# Check command line arguments.
#
if {$argc != 3} {
    puts "usage: load_test.tcl numberofsessions nameofprog numberoftimes"
    exit 1
}

#
# Setup
#
set total_sessions [lindex $argv 0]
set operation [lindex $argv 1]
set number_of_times [lindex $argv 2]
cd output
foreach x [glob *] {
    exec rm $x
}
cd ..

#
# Start sessions
#
puts "Starting $total_sessions sessions"
for {set i 1} {$i <= $total_sessions} {incr i} {
    puts "Starting session $i"
    set time_file_names($i) "output/load_test_session.$i"
    set pids($i) [exec $operation $number_of_times $time_file_names($i) \
	    > output/output.$i &]
}

#
# Kill sessions
#
puts -nonewline "Kill all sessions? (y/n) "
gets stdin ans
if {$ans == "y" || $ans == "Y" || $ans == "yes" || $ans == "YES" || \
	$ans == "Yes"} {
    for {set i 1} {$i <= $total_sessions} {incr i} {
	puts "Killing session $i"
	exec kill -TERM $pids($i)
    }
}
